﻿
XIncludeFile "..\fremde\Date64.pb"

Procedure ClipNumber(Number.i, LowBoundary.i, HighBoundary.i)
  
  If (Number < LowBoundary)
    ProcedureReturn LowBoundary
  EndIf
  
  If (Number > HighBoundary)
    ProcedureReturn HighBoundary
  EndIf
  
  ProcedureReturn Number
  
EndProcedure

Procedure DebugGadget(GadgetNumber.i, InfoMessage$ = "")
  Define LMsg$, ThreadID$
  Define.i TreadID
  
  ThreadID$ = "(" + Str(GetCurrentThreadId_()) + ") :"
  LMsg$ = FormatDate("%hh:%ii:%ss : ", Date64::Date64()) + ThreadID$
  
  If (InfoMessage$ <> "")
    LMsg$ = LMsg$ + " " + InfoMessage$ + " : "
  EndIf
  
  LMsg$ = LMsg$ + "Gadget " + Str(GadgetNumber) + " :  x,y = " + Str(GadgetX(GadgetNumber)) + ", " + GadgetY(GadgetNumber) + " size " + GadgetWidth(GadgetNumber) + ", " + Str(GadgetHeight(GadgetNumber))
  Debug LMsg$
  Debug LMsg$
EndProcedure

Procedure SetStringCursorPosition(StringGadgetID.i, CursorPosition.i)
  SetActiveGadget(StringGadgetID)

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      SendMessage_(GadgetID(StringGadgetID), #EM_SETSEL, CursorPosition, CursorPosition)
    CompilerCase #PB_OS_Linux
      gtk_editable_set_position_(GadgetID(StringGadgetID), CursorPosition)
    CompilerCase #PB_OS_MacOS
      Protected Range.NSRange
      Protected TextView.I

      Range\location = CursorPosition
      Range\length = 0
      TextView = CocoaMessage(0, GadgetID(StringGadgetID), "currentEditor")

      If TextView
        CocoaMessage(0, TextView, "setSelectedRange:@", @Range)
      EndIf
  CompilerEndSelect
EndProcedure

Procedure.i GetStringCursorPosition(StringGadgetID.i)
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      ProcedureReturn SendMessage_(GadgetID(StringGadgetID), #EM_GETSEL, 0, 0) >> 16
    CompilerCase #PB_OS_Linux
      ProcedureReturn gtk_editable_get_position_(GadgetID(StringGadgetID))
    CompilerCase #PB_OS_MacOS
      Protected CursorPosition.I
      Protected TextView.I = CocoaMessage(0, GadgetID(StringGadgetID), "currentEditor")

      If TextView
        CursorPosition = CocoaMessage(0, CocoaMessage(0,
          CocoaMessage(0, TextView, "selectedRanges"),
          "objectAtIndex:", 0), "rangeValue")
      EndIf

      ProcedureReturn CursorPosition
  CompilerEndSelect
EndProcedure

; returns a list of the existing logical drives in this windows system, seperated by space

Procedure.s GetLogicalDrives()
  Define.i f, g
  Define.i BufferLen, Value
  Define.c MyChar
  Define.s DriveList, c$, Result$
  
  BufferLen = 255
  Result$ = ""
  DriveList.s = Space(BufferLen)
  GetLogicalDriveStrings_(BufferLen, DriveList)
  g = 4 * SizeOf(MyChar)
  
  f = @driveList
  For f = 0 To 25
    If (PeekA(@DriveList + (f * g)) = 0)
      Break
    EndIf
    
    C$ = PeekS(@driveList + (f * g), g)
    If (Result$ <> "")
      Result$ + " " + c$
    Else
      Result$ = c$
    EndIf
;    Debug Str(f) + " : " + c$
  Next
  
  ProcedureReturn Result$
EndProcedure

Procedure ShowEditGadgetLastLine(GadgetEditor.i)
  SendMessage_(GadgetID(GadgetEditor), #EM_SCROLLCARET, 0, 0)  
EndProcedure

Procedure IsPathDelimiter(ThisChar$)
  Define.i Result
  
  If (Len(ThisChar$) > 1)
    ThisChar$ = Left(ThisChar$, 1)
  EndIf
  
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      If ((ThisChar$ = "\") Or (ThisChar$ = "/"))
        ProcedureReturn #True
      EndIf
      
    CompilerCase #PB_OS_Linux
      If (ThisChar$ = '\')
        ProcedureReturn #True
      EndIf
      
    CompilerCase #PB_OS_MacOS
      Debug "Mac OS is not supported!"
  CompilerEndSelect
  
  ProcedureReturn #False
  
EndProcedure

; get the number of files with the given extensionmask (*.txt, *.mph) in the given directory

Procedure.i GetNumberOfFiles(ThisDirectory$, ThisExtensionMask$)
  Define.i DirID, Result
  Define ThisExtension$, CurrentExtension$
  
  Result = -1
  DirID = ExamineDirectory(#PB_Any, ThisDirectory$, ThisExtensionMask$)
  If (DirID <> 0)
    Result = 0
    ThisExtension$ = ReplaceString(ThisExtensionMask$, "*.", "")
    
    While NextDirectoryEntry(DirID)
      If (DirectoryEntryType(DirID) = #PB_DirectoryEntry_File)
        CurrentExtension$ = LCase(GetExtensionPart(DirectoryEntryName(DirID)))
        If (ThisExtension$ = CurrentExtension$)
          Result + 1
        EndIf
        
      EndIf
    Wend

    FinishDirectory(DirID)
  EndIf
  
  ProcedureReturn Result
  
EndProcedure

; IDE Options = PureBasic 6.00 LTS (Windows - x64)
; CursorPosition = 139
; FirstLine = 106
; Folding = --
; EnableXP
; CompileSourceDirectory